"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const project_configuration_1 = require("../../generators/utils/project-configuration");
function default_1(tree) {
    var _a, _b;
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        updateDependsOnInsideNxJson(tree);
        const projectsConfigurations = (0, project_configuration_1.getProjects)(tree);
        for (const [projectName, projectConfiguration] of projectsConfigurations) {
            let projectChanged = false;
            for (const [targetName, targetConfiguration] of Object.entries((_a = projectConfiguration.targets) !== null && _a !== void 0 ? _a : {})) {
                for (const dependency of (_b = targetConfiguration.dependsOn) !== null && _b !== void 0 ? _b : []) {
                    if (typeof dependency !== 'string') {
                        if (dependency.projects === 'self') {
                            dependency.projects = '{self}';
                            projectChanged = true;
                        }
                        else if (dependency.projects === 'dependencies') {
                            dependency.projects = '{dependencies}';
                            projectChanged = true;
                        }
                    }
                }
            }
            if (projectChanged) {
                (0, project_configuration_1.updateProjectConfiguration)(tree, projectName, projectConfiguration);
            }
        }
    });
}
exports.default = default_1;
function updateDependsOnInsideNxJson(tree) {
    var _a, _b;
    const nxJson = (0, project_configuration_1.readNxJson)(tree);
    let nxJsonChanged = false;
    for (const [target, defaults] of Object.entries((_a = nxJson === null || nxJson === void 0 ? void 0 : nxJson.targetDefaults) !== null && _a !== void 0 ? _a : {})) {
        for (const dependency of (_b = defaults.dependsOn) !== null && _b !== void 0 ? _b : []) {
            if (typeof dependency !== 'string') {
                if (dependency.projects === 'self') {
                    dependency.projects = '{self}';
                    nxJsonChanged = true;
                }
                else if (dependency.projects === 'dependencies') {
                    dependency.projects = '{dependencies}';
                    nxJsonChanged = true;
                }
            }
        }
    }
    if (nxJsonChanged) {
        (0, project_configuration_1.updateNxJson)(tree, nxJson);
    }
}
//# sourceMappingURL=update-depends-on-to-tokens.js.map